//Usually you will require both swing and awt packages
// even if you are working with just swings.
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
public class GUI implements ActionListener, MouseListener,MouseMotionListener   {

	JButton change;
	JButton reset;
	JTextArea ta;
	JPanel drawingPanel;
	public JTextField entry;
	boolean press = false;
	String mode = "circle";
	int startx=0;
	int starty=0;
	
	BufferedImage offScreen;
	BufferedImage permScreen;

	
	public static void main(String args[]) {
		GUI g=new GUI();   
	}

	public GUI(){
		//Creating the Frame
		JFrame frame = new JFrame("Chat Frame");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(400, 400);



		//Creating the panel at bottom and adding components
		JPanel panel = new JPanel(); // the panel is not visible in output
		JLabel label = new JLabel("Enter Text");
		JTextField tf = new JTextField(10); // accepts upto 10 characters
		change = new JButton("change");
		reset = new JButton("Reset");
		panel.add(label); // Components Added using Flow Layout
		panel.add(label); // Components Added using Flow Layout
		panel.add(tf);
		panel.add(change);
		panel.add(reset);
		entry=tf;
		// Text Area at the Center

		drawingPanel=new JPanel();

		//        ta = new JTextArea();
		drawingPanel.addMouseListener(this);
		drawingPanel.addMouseMotionListener(this);
		//Adding Components to the frame.
		frame.getContentPane().add(BorderLayout.SOUTH, panel);

		frame.getContentPane().add(BorderLayout.CENTER, drawingPanel);
		frame.setVisible(true);
		change.addActionListener(this);
		reset.addActionListener(this);


		offScreen = new BufferedImage(400, 400, BufferedImage.TYPE_INT_ARGB);
		permScreen = new BufferedImage(400, 400, BufferedImage.TYPE_INT_RGB);

		
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();

		if (source == change)
		{            
			//ta.append(entry.getText()+"n");
			if(mode.equals("circle")){
				mode="line";
			} 
			else{
				mode="circle";
			}

			entry.setText(null);
		}
		if (source == reset)
		{
			Graphics g=permScreen.getGraphics();
			g.setColor(new Color(255,255,255));
			g.fillRect(0,0,400,400);
		    drawingPanel.getGraphics().drawImage(permScreen,0,0,null); 
			//ta.setText(null);
		}

	}

	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		int x=e.getX();
		int y=e.getY();
		//ta.setText(x+","+y);
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		press=true;
		if(mode.equals("line")){
			startx=e.getX();
			starty=e.getY();
		}
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		offScreen = new BufferedImage(400, 400, BufferedImage.TYPE_INT_ARGB);

		
		press=false;
		if(mode.equals("line")){
			Graphics g=permScreen.getGraphics();
			g.drawLine(startx,starty,e.getX(),e.getY());
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		offScreen = new BufferedImage(400, 400, BufferedImage.TYPE_INT_ARGB);

		int x=e.getX();
		int y=e.getY();
		
		if(mode.equals("circle")){
			Graphics g=	permScreen.getGraphics();
			g.setColor(Color.red);
			g.drawOval(x, y, 5, 5);
		}
		if(mode.equals("line")){
			Color c= new Color(0,0,0);
			offScreen.getGraphics().setColor(Color.red);
			offScreen.getGraphics().drawLine(startx,starty,x,y);
		}
	    drawingPanel.getGraphics().drawImage(permScreen,0,0,null); 
	    drawingPanel.getGraphics().drawImage(offScreen,0,0,null); 


	}

	@Override
	public void mouseMoved(MouseEvent e) {
		// TODO Auto-generated method stub
		/*int x=e.getX();
		int y=e.getY();
		drawingPanel.getGraphics().drawOval(x, y, 5, 5);*/
		//drawingPanel.setText(x+","+y);

	}
}